| Home | Libraries | People | FAQ | More

#### deref

##### Description

Deferences an iterator.

##### Synopsis

    template<
        typename I
        >
    typename result_of::deref<I>::type deref(I const& i);

Table 1.2. Parameters

Parameter | Requirement | Description
--- | --- | ---
`i` | Model of Forward Iterator | Operation's argument

##### Expression Semantics

    deref(i);

Return type: ``result_of::deref`<I>::type`

Semantics: Dereferences the iterator `i`.

##### Header

    #include <boost/fusion/iterator/deref.hpp>
    #include <boost/fusion/include/deref.hpp>

##### Example

    typedef vector<int,int&> vec;

    int i(0);
    vec v(1,i);
    assert(deref(begin(v)) == 1);
    assert(deref(next(begin(v))) == 0);
    assert(&(deref(next(begin(v)))) == &i);